<?php

namespace App\Http\Controllers; 

use Illuminate\Http\Request;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
use App\Models\Colortone;
use App\Imports\ImportColortone;
use App\Exports\ExportColortone;
use Maatwebsite\Excel\Facades\Excel;
use Auth, DB, Mail, Validator, File, DataTables, Exception;

class ColortoneController extends Controller{
    /** construct */
        public function __construct(){
            $this->middleware('permission:colortone-create', ['only' => ['create']]);
            $this->middleware('permission:colortone-edit', ['only' => ['edit']]);
            $this->middleware('permission:colortone-view', ['only' => ['view']]);
            $this->middleware('permission:colortone-delete', ['only' => ['delete']]);
        }
    /** construct */

    /** index */
        public function index(Request $request){
            if($request->ajax()){
                $data = Colortone::where('status','!=','deleted');
                
                return Datatables::of($data)
                        ->addIndexColumn()
                        ->addColumn('action', function($data){
                            $return = '<div class="btn-group">';

                            if(auth()->user()->can('colortone-view')){
                                $return .= '<a href="'.route('colortone.view', ['id' => base64_encode($data->id)]).'" class="btn btn-default btn-xs">
                                                <i class="fa fa-eye"></i>
                                            </a> &nbsp;';
                            }   
                            
                            if(auth()->user()->can('colortone-edit')){
                                $return .= '<a href="'.route('colortone.edit', ['id' => base64_encode($data->id)]).'" class="btn btn-default btn-xs">
                                                <i class="fa fa-pencil"></i>
                                            </a> &nbsp;';
                           }   

                            if (auth()->user()->can('colortone-delete')) {
                                $return .= '<a href="javascript:;" class="btn btn-default btn-xs dropdown-toggle" data-toggle="dropdown">
                                                    <i class="fa fa-bars"></i>
                                                </a> &nbsp;
                                                <ul class="dropdown-menu">
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="active" data-id="' . base64_encode($data->id) . '">Active</a></li>
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="inactive" data-id="' . base64_encode($data->id) . '">Inactive</a></li>
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="deleted" data-id="' . base64_encode($data->id) . '">Deleted</a></li>
                                                </ul>';
                            }

                            $return .= '</div>';

                            return $return;
                        })

                        ->editColumn('status', function ($data) {
                            if ($data->status == 'active') {
                                return '<span class="badge badge-pill badge-success">Active</span>';
                            } else if ($data->status == 'inactive') {
                                return '<span class="badge badge-pill badge-warning">Inactive</span>';
                            } else if ($data->status == 'deleted') {
                                return '<span class="badge badge-pill badge-danger">Deleted</span>';
                            }
                        })

                        ->rawColumns(['action','status'])
                        ->filter(function ($query) {
                                if (request()->get('colortone', false)) {
                                    $query->where('colortone.name', 'like', "%" . request()->get("colortone") . "%");
                                }
                            })
                        ->make(true);
            }
            return view('colortone.index');
        }
    /** index */

    /** create */
        public function create(Request $request){
            return view('colortone.create');
        }
    /** create */

    /** insert */
        public function insert(Request $request){
            if($request->ajax()) { return true; }
            $crud = [
                'name' => $request->name,
                'status' => 'active',
                'created_at' => date('Y-m-d H:i:s'),
                'created_by' => auth()->user()->id,
                'updated_at' => date('Y-m-d H:i:s'),
                'updated_by' => auth()->user()->id
            ];

            $last_id = Colortone::insertGetId($crud);

            if ($last_id) {
                return redirect()->route('colortone')->with(['success' => 'Record inserted successfully']);
            } else {
                return redirect()->back()->with(['error'=>'Faild to insert Record!'])->withInput();
            }
        
        }
    /** insert */

    /** view */
        public function view(Request $request){
            $id = base64_decode($request->id);
            $data = Colortone::where(['id' => $id])->first();
            
            return view('colortone.view')->with(['data'=>$data]);
        }
    /** view */
    
    /** edit */
        public function edit(Request $request){
            $id = base64_decode($request->id);
            $data = Colortone::where(['id' => $id])->first();

            return view('colortone.edit')->with(['data'=>$data]);
        }
    /** edit */

    /** update */
        public function update(Request $request){
            if($request->ajax()){ return true; }
            $id = $request->id;
            
            $crud = [
                'name' => $request->name,
                'updated_at' => date('Y-m-d H:i:s'),
                'updated_by' => auth()->user()->id
            ];
            DB::enableQueryLog();
            $update = Colortone::where(['id' => $id])->update($crud);
            // dd(DB::getQueryLog());
            if ($update){
                return redirect()->route('colortone')->with(['success' => 'Record updated successfully']);
            }else{
                return redirect()->back()->with(['error'=>'Faild to update Record!'])->withInput();
            }
        }
    /** update */

    /** change-status */
        public function change_status(Request $request){
            if (!$request->ajax()) { exit('No direct script access allowed'); }
            $id = base64_decode($request->id);
            
            $data = Colortone::where(['id' => $id])->first();

            if (!empty($data)) {
                $update = Colortone::where(['id' => $id])->update(['status' => $request->status, 'updated_at' => date('Y-m-d H:i:s'), 'updated_by' => auth('sanctum')->user()->id]);
                if ($update) {
                    return response()->json(['code' => 200]);
                } else {
                    return response()->json(['code' => 201]);
                }
            } else {
                return response()->json(['code' => 201]);
            }
           
        }

    /** Import */
        public function import(Request $request){
           
            if(Excel::import(new ImportColortone, $request->file('file')->store('file'))){
                return redirect()->route('colortone')->with('sucess' ,'File Imported Sucessfully');
            }else{
                return redirect()->route('colortone')->with('error' ,'Faild To Import File!');
            }
        }
    /** Import */
    
    /** Export */
        public function export(Request $request){
            if(isset($request->slug) && $request->slug != null){
                $slug = $request->slug;
            }else{
                $slug = 'all';
            }

            $name = 'Colortones_'.Date('YmdHis').'.xlsx';

            try {
                return Excel::download(new ExportColortone($slug), $name);
            }catch(\Exception $e){
                return redirect()->back()->with('error' ,$e->getMessage());
            }
        }
    /** Export */

}
